import tempfile, os, errno

try:
    tempfile.mkstemp
except AttributeError:

    # backporting mkstemp() where is not available

    def _mymktemp(suffix, prefix, dir):
        if dir is None:
            dir = tempfile.gettempdir()
        if prefix is None:
            prefix = tempfile.gettempprefix()

        while 1:
            i = tempfile._counter.get_next()
            fn = os.path.join(dir, prefix  + str(i) + suffix)
            if not os.path.exists(fn):
                return fn

    def _mkstemp(suffix = "", prefix = None, dir = None, text=False):
        """Helper implementation of tempfile.mkstemp for Python 2.2
        """
        fh = -1
        fn = None
        while fh < 0:
            fn = _mymktemp(suffix, prefix, dir)
            attr = os.O_RDWR | os.O_CREAT | os.O_EXCL | \
                   getattr(os, "O_NOINHERIT", 0) | \
                   getattr(os, "O_NOFOLLOW", 0)
            if not text:
                attr = attr | getattr(os, "O_BINARY", 0)
                fh = os.open(fn, attr, 0600)
        return (fh, fn)
    tempfile.mkstemp = _mkstemp


    def _mkdtemp(suffix = "", prefix = None, dir = None):
        fn = None
        while True:
            fn = _mymktemp(suffix, prefix, dir)
            try:
                os.mkdir(fn, 0700)
                return fn
            except OSError, e:
                if e.errno == errno.EEXIST:
                    continue
                raise
    tempfile.mkdtemp = _mkdtemp
