from os import fork, _exit, setsid, close, open, O_RDONLY, O_WRONLY
from signal import signal, SIGHUP, SIG_IGN
from sys import stdin, stdout, stderr
import logging

_logger = logging.getLogger("api.daemon")

def daemon():

    stdout.flush()
    stderr.flush()

    try:
        pid = fork()
    except OSError, e:
        return ((e.errno, e.strerror))

    if pid != 0:
        _exit(0) #parent terminates

    #child

    setsid()
    signal(SIGHUP, SIG_IGN)

    try:
        pid = fork()
    except OSError, e:
        return ((e.errno, e.strerror))

    if pid != 0:
        _exit(0) #parent terminates

    #child

    for fd in range(0, 3):
        try:
            close(fd)
        except OSError, e:
            pass

    open("/dev/null", O_RDONLY) #stdin
    open("/dev/null", O_WRONLY) #stdout
    open("/dev/null", O_WRONLY) #stderr

    return 0

def background():

    stdout.flush()
    stderr.flush()

    try:
        pid = fork()
    except OSError, e:
        return ((e.errno, e.strerror))

    if pid != 0:
        _exit(0) #parent terminates

    #child

    close(0)
    close(1)
    open("/dev/null", O_RDONLY) #stdin
    open("/dev/null", O_WRONLY) #stdout

    return 0
