from os import unlink, rmdir, listdir
from os.path import isdir, join
from shutil import copyfileobj

def createToFileSaver(outFileName):
    def fileSaver(infh):
        outfh = file(outFileName, "wb")
        try:
            copyfileobj(infh, outfh)
        finally:
            close_nothrow(infh)
            close_nothrow(outfh)
    return fileSaver


def saveToFile(outFileName, fh):
    createToFileSaver(outFileName)(fh)


def close_nothrow(fh):
    try:
        fh.close()
    except:
        pass

def unlink_nothrow(filename):
    try:
        unlink(filename)
    except OSError:
        pass

def unlink_recursively(dirname):
    names = listdir(dirname)
    for name in names:
        fullname = join(dirname, name)
        if isdir(fullname):
            unlink_recursively(fullname)
        else:
            unlink(fullname)
    rmdir(dirname)

# Local Variables:
# mode: python
# indent-tabs-mode: nil
# tab-width: 4
# End:
